#include <bits/stdc++.h>

using namespace std;
#define int int_fast64_t

const int z = 4, inf = INT_MAX;

void bp(int n, vector<int> a, vector<int> t, int m) {
    int l = 0, r = inf;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int res = 0;
        for (int i = 0; i < n; ++i) {
            int tm = mid - a[i] - t[i];
            if (tm > 32) {
                res = inf;
                break;
            } else {
                if (tm >= 0) res += (1 << tm);
                else if (tm + t[i] > 0) res++;
            }
        }
        if (res >= m) r = mid;
        else l = mid;
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        int tm = r - a[i] - t[i];
        if (tm >= 0) res += (1 << tm);
        else if (tm + t[i] > 0) res++;
    }
    if(res == m) cout << l;
    else cout << -1;
}

void solve() {
    int n, m, f = 1;
    cin >> n >> m;
    vector<int> a(n), t(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    cin >> t[0];
    for (int i = 1; i < n; ++i) {
        cin >> t[i];
        if(t[i] != t[0]) f = 0;
    }
    if(f) {
        int s = 0;
        for (int i = 0; i < 32; ++i) {
            s += (int) pow(2, i);
            if(s == m) {
                cout << t[0] + i << endl;
                return;
            }
        }
        cout << -1 << endl;
    }
    else if (n <= 3000) {
        for (int i = 0; i < 7000; ++i) {
            int res = 0;
            for (int j = 0; j < n; ++j) {
                int h = i - a[j] - t[j];
                if (h >= 0) res += (1 << h);
                else if (h + t[j] > 0) res++;
            }
            if(res > m) {
                cout << -1 << endl;
                return;
            }
            if(res == m) {
                cout << i - 1 << endl;
                return;
            }
        }
    } else {
        bp(n, a, t, m);
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}