#include <bits/stdc++.h>

using namespace std;
#define int int_fast64_t

const int inf = LONG_LONG_MAX;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), t(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    int l = 0, r = inf;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int res = 0;
        for (int i = 0; i < n; ++i) {
            int tm = mid - a[i] - t[i];
            if (tm > 32) {
                res = inf;
                break;
            } else {
                if (tm >= 0) res += (1 << tm);
                else if (tm + t[i] > 0) res++;
            }
        }
        if (res >= m) r = mid;
        else l = mid;
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        int tm = r - a[i] - t[i];
        if (tm >= 0) res += (1 << tm);
        else if (tm + t[i] > 0) res++;
    }
    if(res == m) {
        cout << l;
        return;
    }
    r++;
    res = 0;
    for (int i = 0; i < n; ++i) {
        int tm = r - a[i] - t[i];
        if (tm >= 0) res += (1 << tm);
        else if (tm + t[i] > 0) res++;
    }
    if(res == m) {
        cout << l + 1;
        return;
    }
    else cout << -1 << endl;
}

/*

4 11
3 5 1 10
2 9 2 13

13 124
5 6 8 8 1 6 4 6 4 7 10 3 9
5 2 10 5 2 1 1 4 8 3 4 1 9

*/

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}